#ifndef PROCESSESPAGE_H
#define PROCESSESPAGE_H

#include <QWidget>
#include <QStandardItemModel>
#include <QSortFilterProxyModel>
#include <QDebug>
#include <QScrollBar>
#include <QTimer>
#include <QMenu>
#include <QAction>

#include "Managers/info_manager.h"

namespace Ui {
    class ProcessesPage;
}

class ProcessesPage : public QWidget
{
    Q_OBJECT

public:
    explicit ProcessesPage(QWidget *parent = 0);
    ~ProcessesPage();

    bool eventFilter(QObject* obj,QEvent *evt);
private:
    void initPriority(pid_t _pid);
    bool setscheduler(pid_t _pid,int priority,int level);
    void runKAuthAction(const QString &actionId, const int pids, const QVariantMap &options);
private slots:
    void init();
    void loadProcesses();
    void loadHeaderMenu();
    void loadMenu();
    QList<QStandardItem *> createRow(const Process &proc);
    void on_txtProcessSearch_textChanged(const QString &val);
    void on_sliderRefresh_valueChanged(const int &i);
    void on_btnEndProcess_clicked();
    void on_tableProcess_customContextMenuRequested(const QPoint &pos);
    void on_ProcessnormalPriority();
    void on_ProcessfifoPrioritylow();
    void on_ProcessfifoPrioritylanlow();
    void on_ProcessfifoPrioritynormal();
    void on_ProcessfifoPrioritylesshight();
    void on_ProcessfifoPriorityhight();
    void on_ProcessrrPrioritylow();
    void on_ProcessrrPrioritylanlow();
    void on_ProcessrrPrioritynormal();
    void on_ProcessrrPrioritylesshight();
    void on_ProcessrrPriorityhight();
private:
    Ui::ProcessesPage *ui;

    QStandardItemModel *mItemModel;
    QSortFilterProxyModel *mSortFilterModel;
    QModelIndex mSeletedRowModel;
    QStringList mHeaders;
    QMenu mHeaderMenu;
    QMenu mMenu;
    QTimer *mTimer;
    InfoManager *im;
    QAction * selectaction;
    QMenu *priomenu;
    QMenu * menufifo;
    QMenu * menuRR;
    QAction *normal_action;
    QAction *fifo_act_low;
    QAction *fifo_act_tanlow;
    QAction *fifo_act_normal;
    QAction *fifo_act_lesshight;
    QAction *fifo_act_hight;
    QAction *rr_act_low;
    QAction *rr_act_tanlow;
    QAction *rr_act_normal;
    QAction *rr_act_lesshight;
    QAction *rr_act_hight;
};

#endif // PROCESSESPAGE_H
